"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = __importDefault(require("http"));
var core_1 = require("@barajs/core");
var webhooks_1 = __importDefault(require("@octokit/webhooks"));
var app_1 = require("@octokit/app");
var flows = __importStar(require("./flow"));
var Github = core_1.portion(__assign({ name: 'bara-github', mold: {
        port: 7000,
        enableWebhook: true,
    }, init: function (mold) {
        var secret = mold.secret, appId = mold.appId, privateKey = mold.privateKey, enableWebhook = mold.enableWebhook;
        var webhook = null;
        var app = new app_1.App({ id: appId, privateKey: privateKey });
        if (enableWebhook) {
            webhook = new webhooks_1.default({ secret: secret });
        }
        return { webhook: webhook, app: app };
    }, whenInitialized: core_1.flow({
        bootstrap: function (_a) {
            var context = _a.context, mold = _a.mold, next = _a.next;
            var app = context.app, webhook = context.webhook;
            var port = mold.port;
            var jwt = app.getSignedJsonWebToken();
            http_1.default.createServer(webhook.middleware).listen(port, function () {
                next({ port: port, jwt: jwt });
            });
        },
    }) }, flows));
exports.Github = Github;
var _a = core_1.popEvent(Github), whenWebhookListening = _a.whenInitialized, whenAnyHook = _a.whenAnyHook, whenInstallation = _a.whenInstallation, whenPush = _a.whenPush, whenPullRequest = _a.whenPullRequest, whenPullRequestReview = _a.whenPullRequestReview, whenPullRequestReviewComment = _a.whenPullRequestReviewComment, whenBranchCreate = _a.whenBranchCreate, whenBranchDelete = _a.whenBranchDelete, whenIssueComment = _a.whenIssueComment, whenIssues = _a.whenIssues, whenLabel = _a.whenLabel, whenProject = _a.whenProject, whenRepository = _a.whenRepository;
exports.whenWebhookListening = whenWebhookListening;
exports.whenAnyHook = whenAnyHook;
exports.whenInstallation = whenInstallation;
exports.whenPush = whenPush;
exports.whenPullRequest = whenPullRequest;
exports.whenPullRequestReview = whenPullRequestReview;
exports.whenPullRequestReviewComment = whenPullRequestReviewComment;
exports.whenBranchCreate = whenBranchCreate;
exports.whenBranchDelete = whenBranchDelete;
exports.whenIssueComment = whenIssueComment;
exports.whenIssues = whenIssues;
exports.whenLabel = whenLabel;
exports.whenProject = whenProject;
exports.whenRepository = whenRepository;
var _b = core_1.popSeep(whenInstallation), installationSenderLoginIs = _b.installationSenderLoginIs, installationReposIncludes = _b.installationReposIncludes;
exports.installationSenderLoginIs = installationSenderLoginIs;
exports.installationReposIncludes = installationReposIncludes;
// export * from './formula'
exports.default = Github;
//# sourceMappingURL=index.js.map